var checkState = {
    IDLE : 0,
    HALF : 1,
    HOLE : 2
};

CheckPoint = function(game, x, y, tagP) {
    Phaser.Sprite.call(this, game, x, y, tagP);
    this.game = game;
    this.state = checkState.IDLE;
    this.loadAnimations();
    this.player1HitCheckpoint = false;
    this.player2HitCheckpoint = false;
}

CheckPoint.prototype = Object.create(Phaser.Sprite.prototype);
CheckPoint.prototype.constructor = CheckPoint;

CheckPoint.prototype.changeState = function(checkSTT){
    if(this.state == checkSTT)
        return;
    
    console.log(this.state);
    this.state = checkSTT;
    switch(this.state){
            case checkState.IDLE:
                this.animations.play('idle');
            break;
            
            case checkState.HALF:
            if (this.player1HitCheckpoint)
                this.animations.play('halfWhite');
            else
                this.animations.play('halfBlack');
            break;
            
            case checkState.HOLE:
                this.animations.play('hole');
            break;
    }
}

CheckPoint.prototype.loadAnimations = function(){                        
    /// enquanto ainda não tem animação no checkpoint todo mundo só tem um frame
    this.animations.add('idle', [0], 1, true);
    this.animations.add('halfBlack', [1], 1, true);
    this.animations.add('halfWhite', [1], 1, true);
    this.animations.add('hole', [2], 1, true);
}