var teleporterState = {
    ACTIVE : 0,
    INACTIVE : 1
};

Teleporter = function(game, x, y, tag) {
    Phaser.Sprite.call(this, game, x, y, tag);
    this.game = game;
    this.state = teleporterState.INACTIVE;
    this.anchor.setTo(0.5, 1.0);
    this.movingVelocity = 1000;
    this.game.physics.arcade.enable(this);
    this.body.bounce.x = 0.05;
    this.body.bounce.y = 0.05
    this.body.linearDamping = 1.0;
    this.body.collideWorldBounds = true;
    this.alpha = 0.0;
};

Teleporter.prototype = Object.create(Phaser.Sprite.prototype);
Teleporter.prototype.constructor = Teleporter;

//Teleporter.prototype.update = function(){
//    if(this.body.velocity.x = 0 && this.body.velocity.y = 0){
//        this.game.time.events.add(Phaser.Timer.SECOND * 4, deleteitself, this);
//    }
//};

Teleporter.prototype.reset = function(x, y, mx, my) {
    this.state = teleporterState.ACTIVE;
    this.alpha = 1;
    this.body.velocity.x = 0;
    this.body.velocity.y = 0;
    this.x = x;
    this.y = y;
    var dy = my - this.y;
    var dx = mx - this.x;
    var mod = Math.sqrt(Math.pow(dx,2) + Math.pow(dy, 2));
    dy /= mod;
    dx /= mod;
    dy *= this.movingVelocity;
    dx *= this.movingVelocity;
    this.body.velocity.x = dx;
    this.body.velocity.y = dy;
};

Teleporter.prototype.spawnPlayer = function() {
    this.state = teleporterState.INACTIVE;
    this.alpha = 0;
};

Teleporter.prototype.isActive = function() {
    var result = false;
    if (this.state == teleporterState.ACTIVE)
    {
        result = true;
        console.log ('I\'m a teleporter and I\'m active!');
    }
    return result;
};
