//Script 'global' variables
var theGame = function(game)
{
    var player1 = 0;
    var player2 = 0;
    var activePlayer, inactivePlayer;
    var keyJump, keyWalkLeft, keyWalkRight, keySwap, keySpawn, keySwap2;
    var worldGravity = 980;
    var mouseClicked = false;
    var switched = false;
    var swapped = false;
    var playerRiding = false;
    var platform;
    var teleporterHitLeft = false, teleporterHitRight = false;
    var spawnPoint1, spawnPoint2;
    var lastCheckpoint;
    var initialPosition1 = [];
    var initialPosition2 = [];
    var hitCheckpoint = false;

    var allowInput = true;

//        checkpoint.push({x: 0, y: 0});
    var cameraTarget = 0;

    theGame.prototype.create = function()
    {


        game.stage.backgroundColor = 0xffffff;
        this.loadMap();
        this.createGround();
        this.createSpikes();
        this.createEnd();
        this.createRainEmitter();
        this.createCheckpoints();
        this.loadParallaxBG();

        game.physics.startSystem(Phaser.Physics.ARCADE);
        player1 = new Player(game, 200, 400, 'white', 'white_teleporter');
        player1.scale.x = 0.6;
        player1.scale.y = 0.6;

        player2 = new Player(game, 600, 400, 'black', 'black_teleporter');
        player2.scale.x = 0.6;
        player2.scale.y = 0.6;

        game.add.existing(player1);
        game.add.existing(player2);
        game.physics.arcade.enable(player1);
        game.physics.arcade.enable(player2);

        //spawnPoint is an array
        spawnPoint1 = this.findObjectsByType('spawn1', map, 'Layer Objects');
        initialPosition1.push({x: spawnPoint1[0].x, y: spawnPoint1[0].y});
        player1.position = spawnPoint1[0];


        player1.body.setSize(player1.body.width, player1.body.height*0.9, 0, -(player1.body.height*0.3));
        player1.body.collideWorldBounds = true;
        player1.body.bounce.y = 0.0;
        player1.body.bounce.x = 0.0;

        spawnPoint2 = this.findObjectsByType('spawn2', map, 'Layer Objects');
        initialPosition2.push({x: spawnPoint2[0].x, y: spawnPoint2[0].y});
        player2.position = spawnPoint2[0];

        player2.body.setSize(player2.body.width, player2.body.height*0.9, 0, -(player2.body.height*0.3));
        player2.body.collideWorldBounds = true;
        player2.body.bounce.y = 0.0;
        player2.body.bounce.x = 0.0;

        game.physics.arcade.gravity.y = worldGravity;
        activePlayer = player1;
        inactivePlayer = player2;

        this.setupKeys();

        cameraTarget = new CameraTarget(game, activePlayer.x, activePlayer.y, 'teleporter2', 200);
        game.camera.follow(cameraTarget);

        bgmgame = this.game.add.audio('bgmgame');
        bgmgame.play('',0,1,true);
        bgmgame.volume = 0.7;
        sfxcheckpoint = this.game.add.audio('sfxcheckpoint');
        sfxcheckpoint.volume = 0.07;
        sfxdie = this.game.add.audio('sfxdie');
        sfxjump = this.game.add.audio('sfxjump');
        sfxjump.volume = 0.05;
        sfxland = this.game.add.audio('sfxland');
        sfxteleport = this.game.add.audio('sfxteleport');
        sfxteleport.volume = 0.05;
    },

    theGame.prototype.update = function()
    {
//        if(activePlayer.didJustLand)
//            console.log("Did just land");
//        else
//            console.log("Did NOT just land");

        if(activePlayer.didJustLand)
        {
            //playSFX
            activePlayer.didJustLand = false;
        }

        //check if player died
        if (activePlayer.isDead() || inactivePlayer.isDead())
        {
            console.log("Died!");
            //reset player position, state
            if (hitCheckpoint)
            {
                player1.position.x = lastCheckpoint.position.x;
                player1.position.y = lastCheckpoint.position.y + lastCheckpoint.body.height - player1.body.height;

                player2.position.x = lastCheckpoint.position.x;
                player2.position.y = lastCheckpoint.position.y + lastCheckpoint.body.height - player2.body.height;

                player1.setStateIsRespawning();
                player2.setStateIsRespawning();

                player1.stopWalking();
                player2.stopWalking();

                player1.resetHorizontalVelocity();
                player2.resetHorizontalVelocity();

                player1.resetVerticalVelocity();
                player2.resetVerticalVelocity();

                allowInput = true;

                return;
            }
            else
            {
                player1.position.x = initialPosition1[0].x;
                player1.position.y = initialPosition1[0].y - 10;

                player2.position.x = initialPosition2[0].x;
                player2.position.y = initialPosition2[0].y - 10;

                player1.setStateIsRespawning();
                player2.setStateIsRespawning();

                player1.stopWalking();
                player2.stopWalking();

                player1.resetHorizontalVelocity();
                player2.resetHorizontalVelocity();

                player1.resetVerticalVelocity();
                player2.resetVerticalVelocity();

                allowInput = true;

                return;
            }

        }

//            activePlayer.tint   = 0xffffff;
//            inactivePlayer.tint = 0x777777;
        activePlayer.bringToTop();
        inactivePlayer.stopWalking();
        cameraTarget.update(activePlayer.x, activePlayer.y);

        game.physics.arcade.collide(activePlayer, groupGround);
        game.physics.arcade.collide(inactivePlayer, groupGround);
        game.physics.arcade.collide(activePlayer.teleporter, groupGround);

        game.physics.arcade.overlap(activePlayer, groupSpikes, this.collidedSpikes, null, this);
        game.physics.arcade.overlap(inactivePlayer, groupSpikes, this.collidedSpikes, null, this);
        game.physics.arcade.overlap(activePlayer, groupCheckpoints, this.collidedCheckpoint, null, this);
        game.physics.arcade.overlap(inactivePlayer, groupCheckpoints, this.collidedCheckpoint, null, this);
        game.physics.arcade.overlap(activePlayer, groupEnd, this.collidedEnd, null, this);

        if (playerRiding)
        {
            inactivePlayer.body.position.x = activePlayer.body.position.x;
            inactivePlayer.body.position.y = activePlayer.body.position.y - inactivePlayer.body.height - 1;
            inactivePlayer.scale.x = activePlayer.scale.x;
            inactivePlayer.lookingLeft = activePlayer.lookingLeft;
        }

        game.physics.arcade.collide(activePlayer, inactivePlayer, this.playersColliding, null, this);

        activePlayer.update();

        //   Test input for Vertical move
        if (keyJump.isDown && activePlayer.canJump() && allowInput)
        {
            sfxjump.play();
            activePlayer.jump();
        }

        activePlayer.resetHorizontalVelocity();

        if (keyWalkLeft.isDown && allowInput)
        {
            activePlayer.walkLeft();
//                cameraTarget.changeFraming(activePlayer.x, activePlayer.y, directions.LEFT);
            cameraTarget.orientationFactor = -1;
        }
        else if (keyWalkRight.isDown && allowInput)
        {
            activePlayer.walkRight();
//                cameraTarget.changeFraming(activePlayer.x, activePlayer.y, directions.RIGHT);
            cameraTarget.orientationFactor = +1;
        }
        else if (keyWalkLeft.isUp && keyWalkRight.isUp)
        {
            activePlayer.stopWalking();
        }

        //   Check respawns
        var spx, spy;
        var offset = 6;
        spx = activePlayer.teleporter.x;
        spy = activePlayer.teleporter.y;

        if (activePlayer.hasTeleporter())
        {
            if (activePlayer.teleporter.body.touching.left)
            {
                //  |_  or  | <-
                console.log('BAIXO ESQUERDA');
                teleporterHitLeft = true;
                spx -= activePlayer.teleporter.width / 2;
                spx += activePlayer.width / 2;
                spx += offset;

                if (activePlayer.teleporter.body.touching.up)  //  |-
                {
                    spy -= activePlayer.teleporter.height;
                    spy += activePlayer.height;
                    spy += offset;
                }
            }
            else if (activePlayer.teleporter.body.touching.right)
            {
                //  _|  or  -> |
                console.log('BAIXO DIREITA');
                teleporterHitRight = true;
                spx += activePlayer.teleporter.width / 2;
                spx -= activePlayer.width / 2;
                spx -= offset;

                if (activePlayer.teleporter.body.touching.up)  //  -|
                {
                    spy -= activePlayer.teleporter.height;
                    spy += activePlayer.height;
                    spy += offset;
                }
            }
        }

        if (keySpawn.isDown && !switched && allowInput)
        {
            if(activePlayer.teleporter.isActive())
                this.createSpawnEmitter(activePlayer.teleporter);

            if (activePlayer.hasTeleporter() && activePlayer.teleporter.isActive())
            {
                activePlayer.teleporterWasShot = false;
                if (teleporterHitLeft)
                    spx += offset;
                else if (teleporterHitRight)
                    spx -= offset;

                inactivePlayer.teleporterWasShot = true;
                inactivePlayer.spawnAt(spx, spy);

                if (inactivePlayer.hasTeleporter()) inactivePlayer.teleporter.spawnPlayer();
                if (activePlayer.hasTeleporter()) activePlayer.teleporter.spawnPlayer();
                activePlayer.resetHorizontalVelocity();

                var tmpPlayer = inactivePlayer;
                inactivePlayer = activePlayer;
                activePlayer = tmpPlayer;
                cameraTarget.changeFraming(activePlayer.x, activePlayer.y, cameraTarget.direction);
                switched = true;
                sfxteleport.play();
            }
        }
        else if (!keySpawn.isDown)
        {
            switched = false;
        }

        //  Shoot teleporter
        if (game.input.activePointer.isDown && !mouseClicked && !activePlayer.recentlySpawned && !playerRiding && allowInput)
        {
            activePlayer.createTeleporter(game.input.mousePointer.worldX, game.input.mousePointer.worldY);
            mouseClicked = true;
            teleporterHitLeft = false;
            teleporterHitRight = false;
        }
        else if (!game.input.activePointer.isDown)
        {
            mouseClicked = false;
        }

        //  Switch between characters
        if ((keySwap.isDown || keySwap2.isDown) && !swapped && allowInput)
        {
            sfxteleport.play();
            swapped = true;
            if (activePlayer.teleporterWasShot)
            {
                activePlayer.teleporter.spawnPlayer();
                activePlayer.teleporterWasShot = false;
            }

            var tmp = inactivePlayer;
            inactivePlayer = activePlayer;
            activePlayer = tmp;

            activePlayer.stopWalking();

            if (playerRiding)
            {
                activePlayer.jump();
                playerRiding = false;
            }
            else
            {
                inactivePlayer.resetHorizontalVelocity();
            }
        }
        else if (!(keySwap.isDown || keySwap2.isDown))
        {
            swapped = false;
        }

    },

    theGame.prototype.render = function()
    {

//            game.debug.body(groupGround);
//            game.debug.body(platform);
//            game.debug.body(activePlayer);
////            game.debug.body(inactivePlayer);
//        game.time.advancedTiming = true;
//        game.debug.text(game.time.fps + ' FPS' || 'FPS', 2, 100, "#ffffff");
//        game.debug.text('Camera Target X: ' + cameraTarget.x, 2, 30, "#000000");
    },

    theGame.prototype.setupKeys = function()
    {
        keyJump = game.input.keyboard.addKey(Phaser.Keyboard.W);
        keyWalkLeft = game.input.keyboard.addKey(Phaser.Keyboard.A);
        keyWalkRight = game.input.keyboard.addKey(Phaser.Keyboard.D);
        keySwap = game.input.keyboard.addKey(Phaser.Keyboard.S);
        keySpawn = game.input.keyboard.addKey(Phaser.Keyboard.SPACEBAR);
        keySwap2 = game.input.keyboard.addKey(Phaser.Keyboard.SHIFT);
    },

    theGame.prototype.playersColliding = function(active, inactive)
    {
        if (active.body.touching.up)
        {
            if (inactive.body.touching.down)
            {
                playerRiding = true;
            }
            else
            {
                playerRiding = false;
            }
        }
        else if (activePlayer.body.touching.down)
        {
            if (inactivePlayer.body.touching.up)
            {
                activePlayer.resetVerticalVelocity();
            }
        }
        if (activePlayer.body.touching.right)
        {
            if (inactivePlayer.body.touching.left)
            {
                playerRiding = true;
            }
        }
        else if (activePlayer.body.touching.left)
        {
            if (inactivePlayer.body.touching.right)
            {
                playerRiding = true;
            }
        }
    },

    theGame.prototype.collidedSpikes = function(player, spike)
    {
        if (!player.isDead() && !player.isDying() && !player.isRespawning())
        {
            sfxdie.play();
            allowInput = false;
            player.setStateDying();
        }
    },

    theGame.prototype.collidedCheckpoint = function(player, check)
    {
        if (check.state == 2 && lastCheckpoint == check)
                return;
            
//            if(player.key === "player1"){
        if(player.x == player1.x && player.y == player1.y){
            check.player1HitCheckpoint = true;
        }
        else{
            check.player2HitCheckpoint = true;
        }

        if(check.player1HitCheckpoint && check.player2HitCheckpoint){

            check.changeState(checkState.HOLE);
            lastCheckpoint = check;
            hitCheckpoint = true;
        }
        else{
            //somente um jogador tocou o checkpoint
            check.changeState(checkState.HALF);
        }

//            if(!player.isDead() && !player.isDying() && !player.isRespawning())
//                player.setStateDying();
    },

    theGame.prototype.collidedEnd = function(player, check)
    {
        console.log("Acaboooo!");
        bgmgame.stop();
        this.game.state.start('StateGameOver');

//        sprMessage = this.game.add.sprite(this.cameraTarget.x, cameraTarget , 'finalMessage');
////        sprMessage.alpha = 0.0;
//        sprMessage.position = activePlayer.position;
////        sprMessage.anchor.set(1.0);
////        sprMessage.anchor.set(1.0);
//        sprMessage.bringToTop();
////        sprMessage.alpha = 1.0;
//
//        sprMessage.anchor.set(0.5);
//        sprMessage.z = 1000;

//        allowInput = false;
    },

    theGame.prototype.loadMap = function()
    {
        map = game.add.tilemap('tilemap');
        map.addTilesetImage('tilesheet');
        foregroundLayer = map.createLayer('tile_layer_1');

        foregroundLayer.resizeWorld();
    },

    theGame.prototype.createGround = function()
    {
        var groundObjects = this.findObjectsByType('ground', map, 'Layer Objects');

        //create corners
        groupGround = game.add.group();
        groupGround.enableBody = true;
        groundObjects.forEach(function(element)
        {
            this.createFromTiledObject(element, groupGround);
        }, this);
    },

    theGame.prototype.createSpikes = function()
    {
        var spikeObjects = this.findObjectsByType('spike', map, 'Layer Objects');

        //create corners
        groupSpikes = game.add.group();
        groupSpikes.enableBody = true;

        spikeObjects.forEach(function(element)
        {
            this.createFromTiledObject(element, groupSpikes);
        }, this);
    },

    theGame.prototype.createEnd = function()
    {
        var endObjects = this.findObjectsByType('end', map, 'Layer Objects');

        //create corners
        groupEnd = game.add.group();
        groupEnd.enableBody = true;

        endObjects.forEach(function(element)
        {
            this.createFromTiledObject(element, groupEnd);
        }, this);
    },

    theGame.prototype.findObjectsByType = function(type, map, layer)
    {
        var result = new Array();

        map.objects[layer].forEach(function(element)
        {
            if (element.properties.type === type)
            {
                //Phaser uses top left, Tiled bottom left so we have to adjust
                //also keep in mind that the cup images are a bit smaller than the tile which is 16x16
                //so they might not be placed in the exact position as in Tiled
                //            element.y -= map.tileHeight;
                result.push(element);
            }
        });
        return result;
    },

    theGame.prototype.createFromTiledObject = function(element, group)
    {
        var sprite = group.create(element.x, element.y, 'roundy');
        //copy all properties to the sprite
        Object.keys(element.properties).forEach(function(key)
        {
            sprite[key] = element.properties[key];
        });

        sprite.alpha = 0.0;

        sprite.body.allowGravity = false;
        sprite.body.immovable = true;
        sprite.body.width = element.width;
        sprite.body.height = element.height;
    },

    theGame.prototype.createRainEmitter = function()
    {
        var emitter = game.add.emitter(game.world.centerX, 0, 400);

        emitter.width = game.world.width;
        // emitter.angle = 30; // uncomment to set an angle for the rain.

        emitter.makeParticles('rain');

        emitter.minParticleScale = 0.3;
        emitter.maxParticleScale = 0.8;

        emitter.setYSpeed(300, 500);
        emitter.setXSpeed(-5, 5);

        emitter.minRotation = 0;
        emitter.maxRotation = 0;

        emitter.start(false, 1600, 5, 0);
    },

    theGame.prototype.createSpawnEmitter = function(tele)
    {
        emitterSpawn = game.add.emitter(tele.position.x, tele.position.y-player1.height, 200);
        emitterSpawn.makeParticles('spark');
        emitterSpawn.setYSpeed(-200, 50);
        emitterSpawn.setAlpha(0.2, 0.7, Phaser.Easing.Linear );

        emitterSpawn.start(false, 3000, 0.5, 25, true);
    },
    
    theGame.prototype.createCheckpoints = function()
    {
            
            groupCheckpoints = game.add.group();
            groupCheckpoints.enableBody = true;
//            return;
            var checkpointObjects = this.findObjectsByType('checkpoint', map, 'Layer Objects');

            checkpointObjects.forEach(function(element){
                this.createCheck(element, groupCheckpoints);
            }, this);
        },
    
    theGame.prototype.createCheck = function(element, group)
    {
            var sprite = new CheckPoint(game, element.x, element.y, 'checkpoint');
            game.physics.arcade.enable(sprite);
//            var sprite = group.create(element.x, element.y, 'checkpoint');
            //copy all properties to the sprite
            Object.keys(element.properties).forEach(function(key){
                sprite[key] = element.properties[key];
            });
            sprite.body.allowGravity = false;
            sprite.body.immovable = true;
            sprite.body.width = element.width;
            sprite.body.height = element.height;
            group.add(sprite);

    }

    theGame.prototype.loadParallaxBG = function()
    {
        var test = this.game.add.sprite(0,0,'background3');
    }
}
